﻿using CommunityToolkit.Maui;
using $safeprojectname$.Services;
using $safeprojectname$.View;
using $safeprojectname$.ViewModel;
using Microsoft.Extensions.Logging;

namespace $safeprojectname$;

public static class MauiProgram
{
	public static MauiApp CreateMauiApp()
	{
		var builder = MauiApp.CreateBuilder();
		builder
			.UseMauiApp<App>()
			.UseMauiCommunityToolkit()
			.ConfigureFonts(fonts =>
			{
				fonts.AddFont("OpenSans-Regular.ttf", "OpenSansRegular");
				fonts.AddFont("OpenSans-Semibold.ttf", "OpenSansSemibold");
                fonts.AddFont("fa-brands.ttf", "FABrands");
                fonts.AddFont("fa-regular.ttf", "FARegular");
                fonts.AddFont("fa-solid.ttf", "FASolid");
			});

        // Services
        builder.Services.AddSingleton<ConnexionService>();

		// Views
		builder.Services.AddSingleton<AboutView>();
		builder.Services.AddSingleton<SettingsView>();
		builder.Services.AddSingleton<VivantEditionView>();
		builder.Services.AddSingleton<VivantView>();

        // ViewModels
		builder.Services.AddSingleton<AboutViewModel>();
		builder.Services.AddSingleton<SettingsViewModel>();
		builder.Services.AddSingleton<VivantEditionViewModel>();
        builder.Services.AddSingleton<VivantViewModel>();


#if DEBUG
        builder.Logging.AddDebug();
#endif

		return builder.Build();
	}
}
