﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net.NetworkInformation;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace $safeprojectname$.Services
{
    public class ConnexionService : INotifyPropertyChanged
    {
        private bool isINRAE;
        public bool IsINRAE
        {
            get => isINRAE;
            set => SetProperty(ref isINRAE, value);
        }

        // e est null à l'init
        public async Task SetIsConnected(ConnectivityChangedEventArgs e = null)
        {
            bool internetAccess = e is null ? Connectivity.NetworkAccess == NetworkAccess.Internet : e.NetworkAccess == NetworkAccess.Internet;
            // Test de l'accès au serveur
            try
            {
                await Task.Run(() =>
                {
                    IsINRAE = new Ping().Send("138.102.166.28").Status == IPStatus.Success || new Ping().Send("147.100.200.52").Status == IPStatus.Success;
                });
                IsINRAE = internetAccess && IsINRAE;
            }
            catch (Exception)
            {
                IsINRAE = false;
            }
        }

        public ConnexionService()
        {
            Connectivity.ConnectivityChanged += Connectivity_ConnectivityChanged;
            Task.Run(() => this.SetIsConnected()).Wait();
            // ou : new Action(async () => await SetIsConnected())();
        }

        ~ConnexionService()
        {
            Connectivity.ConnectivityChanged -= Connectivity_ConnectivityChanged;
        }

        public void Connectivity_ConnectivityChanged(object sender, ConnectivityChangedEventArgs e)
        {
            Task.Run(() => this.SetIsConnected(e)).Wait();
        }

        #region INPC
        public event PropertyChangedEventHandler PropertyChanged;

        protected bool SetProperty<T>(ref T storage, T value, [CallerMemberName] string propertyname = null)
        {
            if (Equals(storage, value)) return false;

            storage = value;
            OnPropertyChanged(propertyname);
            return true;
        }

        private void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion
    }
}
